# Исследователь искривленных пространств для Squeak [2013]

<iframe src="//player.vimeo.com/video/71173349" width="600" height="338" frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe>

Исследователь искривленных пространств для Squeak/Smalltalk является однопользовательской версией исследователя искривленных пространств из Крестьянство SDK и для запуска не требует образа Крестьянство. По сути является прямым наследником программы Curved Spaces, разработанной Джеф Виксом на языке C (http://geometrygames.org).

Целью проекта является - сделать исследователь искривленных пространств на Smalltalk доступным для сообщества http://www.squeak.org и его современной реализации Smalltalk на сегодня (версия 4.4 и 4.5), а так же для сообщества электронных игрушек EToys http://www.squeakland.org. Так каждый человек, использующий Squeak/Smalltalk в своей работе, может запустить исследователь искривленных пространств без требований к настройке системы для рапределенных вычислений на основе Open Croquet.

![CCSE](../images/projects/ccse-screen.jpg "CCSE")

Проект является открытым Open Source и исходный код доступен по адресу http://sdk.krestianstvo.org/sdk/ccse.html

Для запуска исследователя искривленных пространств для Squeak потребуется:

Скачать с официального сайта последнюю версию Squeak http://ftp.squeak.org/4.4/Squeak-4.4-All-in-One.zip
Использовать одну из последних виртуальных машин для Smalltalk CogVM http://www.mirandabanda.org/files/Cog/VM/
В запущенном образе выполнить в редакторе:

"1. Load FFI"

(Installer repository: 'http://source.squeak.org/FFI') install: 'FFI-Pools'; install: 'FFI-Kernel'; install: 'FFI-Tests'.

"2. Load 3DTransform "

(Installer repository: 'http://www.squeaksource.com/CroquetGL') install: '3DTransform'.

"3. Load OpentGL and CCSE"

(Installer repository: 'http://sdk.krestianstvo.org/sdk/ccse') install: 'OpenGL-Pools'; install: 'OpenGL-Core'; install: 'OpenGL-NameManager'; install: 'CCSpaceExplorer'.

"4. Run sample application"


CCSEMorphRender runApp

---

Краткая инструкция по работе с программой:

стрелки на клавиатуре "вверх" и "вниз" - управление скоростью передвижения корабля

стрелки на клавиатуре "лево" и "право" - изменение апертуры

движение мышью в окне с нажатой левой клавишей мыши - вращение коробля

движение мышью в окне с нажатой левой клавишей мыши и зажатой на клавиатуре клавишей "shift" - перемещение коробля

клавиша "o" oна клавиатуре - переключение между вращением головы и тела коробля

клавиша "p" oна клавиатуре - переключение в режим стерео 3D (анаглиф красные-зеленые очки)

клавиша "l" oна клавиатуре - включение поддержки шейдеров (доступно только на компьютерах Mac)

Так же дорступен для скачивания готовый образ Squeak4.4 с предустановленной версией исследователя искривленных пространств: http://krestianstvo.org/sdk/Squeak4.4-12327-ccse.zip

![CCSE2](../images/projects/ccse-screen2.jpg "CCSE")
